<?php
defined('BASEPATH') or exit('No direct script access allowed');

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

class ExportXls extends CI_Controller
{
    private $filaDocumentoGeneral = 2;
    private $filaDocumentoTech = 2;
    private $filaDocumentoAdd = 2;
    private $filaDocumentoLegal = 2;
    private $filaProjectLot = 2;

    public function __construct()
    {
        parent::__construct();
        $this->load->model("Xlsexport_model");
    }

    public function exportDatosCompletos()
    {
        $licitacionesResult = $this->Xlsexport_model->getLicitaciones();
        $result = array();

        //$start = $this->starttime();
        if ($licitacionesResult['num_rows'] > 0) {
            $result = $this->mapearDatos($licitacionesResult);
        }
        $spreadsheet = new Spreadsheet();
        //$sheet = $spreadsheet->getActiveSheet();
        //$sheet->setCellValue('A1', 'Hello World !');

        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();
        $spreadsheet->createSheet();

        $filaExcel = 1;
        foreach ($result as $dato) {
            if ($filaExcel == 1) {
                $spreadsheet = $this->cabecerasOpenPlacspFirstSheet($spreadsheet);
                /*$spreadsheet = $this->cabecerasOpenPlacsBitacora($spreadsheet, 1);
            $spreadsheet = $this->cabeceraMediosComunicacion($spreadsheet);
            $spreadsheet = $this->cabeceraMediosComunicacionDocumentos($spreadsheet);
            $spreadsheet = $this->cabeceraTenderResult($spreadsheet);
            $spreadsheet = $this->cabeceraTenderingTerms($spreadsheet);
            $spreadsheet = $this->cabeceraTipoProcedimiento($spreadsheet);
            $spreadsheet = $this->cabeceraCriterioADjudicacion($spreadsheet);
            $spreadsheet = $this->cabeceraCriteriosFinancieros($spreadsheet);
            $spreadsheet = $this->cabeceraCriteriosTecnicos($spreadsheet);
            $spreadsheet = $this->cabeceraRequisitosParticipacion($spreadsheet);
            $spreadsheet = $this->cabecerasOpenPlacspDocumentos($spreadsheet, 11);
            $spreadsheet = $this->cabecerasOpenPlacspDocumentos($spreadsheet, 12);
            $spreadsheet = $this->cabecerasOpenPlacspDocumentos($spreadsheet, 13);
            $spreadsheet = $this->cabecerasOpenPlacspDocumentos($spreadsheet, 14);*/
            } else {
                $spreadsheet = $this->datosCompletosHojaLicitacion($spreadsheet, $filaExcel, $dato);
                /*$spreadsheet = $this->datosCompletosHojaBitacora($spreadsheet, $dato);
            $spreadsheet = $this->datosCompletosDocumentosGenerales($spreadsheet, $dato);
            $spreadsheet = $this->datosCompletosDocumentosTecnicos($spreadsheet, $dato);
            $spreadsheet = $this->datosCompletosDocumentosAdicionales($spreadsheet, $dato);
            $spreadsheet = $this->datosCompletosDocumentosLegales($spreadsheet, $dato);*/
            }
            //$spreadsheet = $this->datosCompletosMediosPublicacion($spreadsheet);
            //$spreadsheet = $this->datosMedioPublicacion($spreadsheet);
            /*$spreadsheet = $this->datosCompletosResultadoDelProcedimiento($spreadsheet);
            $spreadsheet = $this->datosCompletosOfertas($spreadsheet);
            $spreadsheet = $this->datosCriterioAdjudicacion($spreadsheet);
            $spreadsheet = $this->datosCriterioEvaluacionFinanciera($spreadsheet);
            $spreadsheet = $this->datosCriterioEvaluacionTecnica($spreadsheet);
            $spreadsheet = $this->datosRequisitosParticipacion($spreadsheet);
            $spreadsheet = $this->datosCompletosTipoProcedimiento($spreadsheet);*/

            $filaExcel++;
        }

        $nombreAchivo = 'test.xlsx';
        $ruta = FCPATH . 'uploads/' . $nombreAchivo;

        $writer = new Xlsx($spreadsheet);

        $writer->save($ruta);

        // Write the Excel file to filename some_excel_file.xlsx in the current directory
        // Redirect output to a client’s web browser (Excel5)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename=' . $nombreAchivo . '');
        header('Pragma: cache');
        header('Cache-Control: private');
        //$objWriter = PHPExcel_IOFactory::createWriter($spreadsheet, 'Excel2007');
        //$objWriter->save(FCPATH . 'uploads/' . $nombreAchivo);*/
    }

    public function starttime()
    {
        $r = explode(' ', microtime());
        $r = $r[1] + $r;
        return $r;
    }

    public function endtime($starttime)
    {
        $r = explode(' ', microtime());
        $r = $r[1] + $r;
        $r = round($r - $starttime, 4);
        return '<strong>Execution Time</strong>: ' . $r . ' seconds<br />';
    }

    public function mapearDatos($licitacionesResult): array
    {
        $result = array();
        foreach ($licitacionesResult['datos'] as $licitacion) {
            $result[$licitacion->id_licitacion]['licitacion'] = array(
                'id_licitacion' => $licitacion->id_licitacion,
                "link_uri" => $licitacion->link_uri,
                "updated" => $licitacion->updated,
            );
            $result[$licitacion->id_licitacion]['contract'] = array(
                "descripcion" => $licitacion->contrato_status,
                "contractFolderStatusCode" => $licitacion->contractFolderStatusCode,
                "contractFolderID" => $licitacion->contractFolderID,
            );
            $result[$licitacion->id_licitacion]['locatedParty'] = array(
                "contractingPartyTypeCode" => $licitacion->contractingPartyTypeCode,
                "buyerProfileURIID" => $licitacion->buyerProfileURIID,
                "tipo_administracion" => $licitacion->tipo_administracion,
            );
            $result[$licitacion->id_licitacion]['party'] = array(
                "partyName" => $licitacion->partyName,
                "codpostal" => $licitacion->codpostal,
                "websiteURI" => $licitacion->websiteURI,
                "city" => $licitacion->city,
                "direccion" => $licitacion->direccion,
                "contact_name" => $licitacion->contact_name,
                "contact_email" => $licitacion->contact_email,
            );

            /*foreach ($result[$licitacion->id_licitacion]['party'] as $row) {
            $result[$licitacion->id_licitacion]['partyActivity'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_party_party_idenfitication", "id_ajena_licitacion", $row['id']);
            }*/

            $result[$licitacion->id_licitacion]['project'] = array(
                "name" => $licitacion->name,
                "estimatedOverallContractAmount" => $licitacion->estimatedOverallContractAmount,
                "taxExclusiveAmount" => $licitacion->taxExclusiveAmount,
                "totalAmount" => $licitacion->totalAmount,
                "tipo_contrato" => $licitacion->tipo_contrato,
                "countrySubentityCode" => $licitacion->countrySubentityCode,
                "countrySubentity" => $licitacion->countrySubentity,
                "durationMesure" => $licitacion->durationMesure,
                "medida" => $licitacion->medida,
                "duracion_inicio" => $licitacion->duracion_inicio,
                "duracion_fin" => $licitacion->duracion_fin,
                "contractExtension" => $licitacion->contractExtension,

            );

            $result[$licitacion->id_licitacion]['tenderProcess'] = array(
                "tipoTender" => $licitacion->tipoTender,
                "contrato_sistema" => $licitacion->contrato_sistema,
                "urgency" => $licitacion->urgency,
                "submision" => $licitacion->submision,
            );

            $result[$licitacion->id_licitacion]['tenderTerms'] = array(
                "procurementLegislationDocumentReference" => $licitacion->procurementLegislationDocumentReference,
                "allowedSubcontractTerms" => $licitacion->allowedSubcontractTerms,
            );
            /*foreach ($result[$licitacion->id_licitacion]['project'] as $row) {
            //$result[$licitacion->id_licitacion]['projectActivity'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_procurement_project_itemClass", "id_ajena_licitacion", $row['id']);
            }*/

            /*$result[$licitacion->id_licitacion]['projectLot'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_procurement_project_lot", $licitacion->id_licitacion);
            foreach ($result[$licitacion->id_licitacion]['projectLot'] as $row) {
            //$result[$licitacion->id_licitacion]['projectLotActivity'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_procurement_project_lot_item", "id_ajena_licitacion", $row['id']);
            }*/

            /*$result[$licitacion->id_licitacion]['tenderResult'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_tender_result", $licitacion->id_licitacion);
        $result[$licitacion->id_licitacion]['tenderProcess'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_tendering_process", $licitacion->id_licitacion);
        $result[$licitacion->id_licitacion]['tenderTerms'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_tendering_terms", $licitacion->id_licitacion);
        $result[$licitacion->id_licitacion]['validNoticeInfo'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_valid_notice_info", $licitacion->id_licitacion);
        $result[$licitacion->id_licitacion]['techDocs'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_technical_documents", $licitacion->id_licitacion);
        $result[$licitacion->id_licitacion]['legalDocs'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_legal_documents", $licitacion->id_licitacion);
        $result[$licitacion->id_licitacion]['generalDocs'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_general_documents", $licitacion->id_licitacion);
        $result[$licitacion->id_licitacion]['additDocs'] = $this->Xlsexport_model->getDatosByTablaAndLicitacion("maestro_additional_documents", $licitacion->id_licitacion);*/
        }

        return $result;
    }

    private function datosCompletosHojaLicitacion($spreadsheet, $filaExcel, $datosLicitacion)
    {

        $sheet = $spreadsheet->getSheet(0);
        $sheet->setTitle("Datos Licitación");
        $styleArr = array(
            "font" => array(
                "bold" => true,
                "color" => array("rgb" => "22B9FF"),
                "size" => 13,
            ),
        );
        $updatedFormat = new DateTime($datosLicitacion['licitacion']['updated']);
        $updated = \PhpOffice\PhpSpreadsheet\Shared\Date::PHPToExcel($updatedFormat);
        $sheet->getStyle("A1:AB1")->applyFromArray($styleArr);
        $sheet->setCellValue('A' . $filaExcel, $datosLicitacion['licitacion']['id_licitacion']);
        $sheet->setCellValue('B' . $filaExcel, $datosLicitacion['licitacion']['link_uri']);
        $sheet->setCellValue('C' . $filaExcel, $updated);
        $sheet->getStyle('C' . $filaExcel)
            ->getNumberFormat()
            ->setFormatCode(\PhpOffice\PhpSpreadsheet\Style\NumberFormat::FORMAT_DATE_DATETIME);
        $sheet->setCellValue('E' . $filaExcel, "");
        $sheet->setCellValue('F' . $filaExcel, $datosLicitacion['contract']['descripcion']);
        $sheet->setCellValue('G' . $filaExcel, $datosLicitacion['contract']['contractFolderID']);
        $sheet->setCellValue('H' . $filaExcel, $datosLicitacion['project']['name']);
        $sheet->setCellValue('I' . $filaExcel, $datosLicitacion['project']['estimatedOverallContractAmount']);
        $sheet->setCellValue('J' . $filaExcel, $datosLicitacion['project']['taxExclusiveAmount']);
        $sheet->setCellValue('K' . $filaExcel, $datosLicitacion['project']['totalAmount']);

        /*$cpvProject = "";
        for ($i = 0; $i < count($datosLicitacion['projectActivity']); $i++) {
        $cpvProject .= $datosLicitacion['projectActivity'][$i]['itemClassification_value'] . ";";
        }*/

        /*$cpvParty = "";
        //TODO OBtener solo el DIR3
        for ($i = 0; $i < count($datosLicitacion['partyActivity']); $i++) {
        $cpvParty .= $datosLicitacion['partyActivity'][$i]['idPartyIdent'] . ";";
        }*/

        $sheet->setCellValue('L' . $filaExcel, ""); //$cpvProject);
        $sheet->setCellValue('M' . $filaExcel, $datosLicitacion['project']['tipo_contrato']);
        $sheet->setCellValue('N' . $filaExcel, $datosLicitacion['project']['countrySubentityCode'] . " - " . $datosLicitacion['project']['countrySubentity']);
        $sheet->setCellValue('O' . $filaExcel, $datosLicitacion['party']['partyName']);
        $sheet->setCellValue('P' . $filaExcel, "");
        $sheet->setCellValue('Q' . $filaExcel, $datosLicitacion['locatedParty']['contractingPartyTypeCode']);
        $sheet->setCellValue('R' . $filaExcel, ""); //$cpvParty);
        $sheet->setCellValue('S' . $filaExcel, $datosLicitacion['locatedParty']['buyerProfileURIID']); //Buscar DIR3
        $sheet->setCellValue('T' . $filaExcel, $datosLicitacion['locatedParty']['tipo_administracion']);
        $sheet->setCellValue('U' . $filaExcel, $datosLicitacion['party']['codpostal']);
        $sheet->setCellValue('V' . $filaExcel, $datosLicitacion['tenderProcess']['tipoTender']);
        $sheet->setCellValue('W' . $filaExcel, $datosLicitacion['tenderProcess']['contrato_sistema']);
        $sheet->setCellValue('X' . $filaExcel, $datosLicitacion['tenderProcess']['urgency']);
        $sheet->setCellValue('Y' . $filaExcel, $datosLicitacion['tenderProcess']['submision']);
        $sheet->setCellValue('Z' . $filaExcel, $datosLicitacion['tenderTerms']['procurementLegislationDocumentReference']);
        $sheet->setCellValue('AA' . $filaExcel, $datosLicitacion['tenderTerms']['allowedSubcontractTerms']);
        $sheet->setCellValue('AB' . $filaExcel, $datosLicitacion['project']['durationMesure']);
        $sheet->setCellValue('AC' . $filaExcel, $datosLicitacion['project']['medida']);
        $sheet->setCellValue('AD' . $filaExcel, $datosLicitacion['project']['duracion_inicio']);
        $sheet->setCellValue('AE' . $filaExcel, $datosLicitacion['project']['duracion_fin']);
        $sheet->setCellValue('AF' . $filaExcel, $datosLicitacion['project']['contractExtension']);
        $sheet->setCellValue('AG' . $filaExcel, $datosLicitacion['party']['websiteURI']);
        $sheet->setCellValue('AH' . $filaExcel, $datosLicitacion['party']['city']);
        $sheet->setCellValue('AI' . $filaExcel, $datosLicitacion['party']['direccion']);
        $sheet->setCellValue('AJ' . $filaExcel, $datosLicitacion['party']['contact_name']);
        $sheet->setCellValue('AK' . $filaExcel, $datosLicitacion['party']['contact_email']);

        return $spreadsheet;

    }

    private function datosCompletosHojaBitacora($spreadsheet, $datosLicitacion)
    {
        $spreadsheet->setActiveSheetIndex(1);
        $spreadsheet->getActiveSheet()->setTitle("Bitácora");

        foreach ($datosLicitacion['projectLot'] as $datos) {
            $spreadsheet->getActiveSheet()->SetCellValue('A' . $this->filaProjectLot, $datos['id_ajena_licitacion']);
            $spreadsheet->getActiveSheet()->SetCellValue('B' . $this->filaProjectLot, $datos['name']);
            $spreadsheet->getActiveSheet()->SetCellValue('C' . $this->filaProjectLot, $datos['idProcurementLot']);
            $spreadsheet->getActiveSheet()->SetCellValue('D' . $this->filaProjectLot, $datos['totalAmount']);
            $spreadsheet->getActiveSheet()->SetCellValue('E' . $this->filaProjectLot, $datos['taxExclusiveAmount']);
            $spreadsheet->getActiveSheet()->SetCellValue('F' . $this->filaProjectLot, $datos['countrySubentity']);
            $spreadsheet->getActiveSheet()->SetCellValue('G' . $this->filaProjectLot, $datos['countrySubentityCode']);
            $spreadsheet->getActiveSheet()->SetCellValue('H' . $this->filaProjectLot, $datos['nameLocation']);

            $cpv = "";
            $projectLotActivity = $this->Xlsexport_model->getProjectLotActivityByProjectLot($datos['id']);

            if ($projectLotActivity['num_rows'] > 0) {
                for ($i = 0; $i < count($projectLotActivity['datos']); $i++) {

                    $cpv .= $projectLotActivity['datos'][$i]['idItem'] . ";";
                }
                $spreadsheet->getActiveSheet()->SetCellValue('I' . $this->filaProjectLot, $cpv);
            }
            $this->filaProjectLot++;
        }
        return $spreadsheet;
    }

    private function datosCompletosMediosPublicacion($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(2);
        $spreadsheet->getActiveSheet()->setTitle("Medios de publicación");
        $datos = $this->Xlsexport_model->getValidNoticeInfoRelacion();

        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $datos) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['noticeTypeCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('C' . $aux, $datos['publicationMediaName']);
                $aux++;
            }
        }

        return $spreadsheet;
    }

    private function datosMedioPublicacion($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(3);
        $spreadsheet->getActiveSheet()->setTitle("Documentos Medios Comm");
        $datos = $this->Xlsexport_model->getDatosRelacionadasTablaWithoutLicitacion("maestro_valid_notice_info_documento", "maestro_valid_notice_info", "id_ajena_vni");
        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $row) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $row['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $row['documento']);
                $spreadsheet->getActiveSheet()->SetCellValue('C' . $aux, $row['filename']);

                $aux++;
            }
        }
        return $spreadsheet;
    }

    private function datosCompletosResultadoDelProcedimiento($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(4);
        $spreadsheet->getActiveSheet()->setTitle("Resultado del Procedimiento");

        $datos = $this->Xlsexport_model->getTenderResult("maestro_tender_result");
        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $datos) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['resultCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('C' . $aux, $datos['description']);
                $spreadsheet->getActiveSheet()->SetCellValue('D' . $aux, $datos['awardDate']);
                $spreadsheet->getActiveSheet()->SetCellValue('E' . $aux, $datos['receivedTenderQuantity']);
                $spreadsheet->getActiveSheet()->SetCellValue('F' . $aux, $datos['lowerTenderAmount']);
                $spreadsheet->getActiveSheet()->SetCellValue('G' . $aux, $datos['higherTenderAmount']);
                $spreadsheet->getActiveSheet()->SetCellValue('H' . $aux, $datos['startDate']);
                $spreadsheet->getActiveSheet()->SetCellValue('I' . $aux, $datos['smeawardedIndicator']);
                $spreadsheet->getActiveSheet()->SetCellValue('J' . $aux, $datos['contract_id']);
                $spreadsheet->getActiveSheet()->SetCellValue('K' . $aux, $datos['contract_issueDate']);
                $spreadsheet->getActiveSheet()->SetCellValue('L' . $aux, $datos['partyIdentification']);
                $spreadsheet->getActiveSheet()->SetCellValue('M' . $aux, $datos['partyName']);
                $spreadsheet->getActiveSheet()->SetCellValue('N' . $aux, $datos['TaxExclusiveAmount']);
                $spreadsheet->getActiveSheet()->SetCellValue('O' . $aux, $datos['PayableAmount']);

                $aux++;
            }
        }
        return $spreadsheet;
    }

    private function datosCompletosTipoProcedimiento($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(5);
        $spreadsheet->getActiveSheet()->setTitle("Tipo Procedimiento");

        $datos = $this->Xlsexport_model->getTenderProcessRelacion();
        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $datos) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['procedureCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('C' . $aux, $datos['urgencyCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('D' . $aux, $datos['contractingSystemCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('E' . $aux, $datos['partPresentationCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('F' . $aux, $datos['submissionMethodCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('G' . $aux, $datos['maximumLotPresentationQuantity']);
                $spreadsheet->getActiveSheet()->SetCellValue('H' . $aux, $datos['maximumTendererAwardedLotsQuantity']);
                $spreadsheet->getActiveSheet()->SetCellValue('I' . $aux, $datos['lotsCombinationContractingAuthorityRights']);
                $spreadsheet->getActiveSheet()->SetCellValue('J' . $aux, $datos['deadLineEndDate']);
                $spreadsheet->getActiveSheet()->SetCellValue('K' . $aux, $datos['deadLineEndTime']);
                $spreadsheet->getActiveSheet()->SetCellValue('L' . $aux, $datos['deadLineDescription']);
                $spreadsheet->getActiveSheet()->SetCellValue('M' . $aux, $datos['auctionTerms']);
                $spreadsheet->getActiveSheet()->SetCellValue('N' . $aux, $datos['documentAvailablePeriod_EndDate']);
                $spreadsheet->getActiveSheet()->SetCellValue('O' . $aux, $datos['documentAvailablePeriod_EndTime']);

                $aux++;
            }
        }

        return $spreadsheet;
    }

    private function datosCompletosOfertas($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(6);
        $spreadsheet->getActiveSheet()->setTitle("Ofertas");

        $datos = $this->Xlsexport_model->getTenderingTermsGarantia("maestro_tendering_terms");
        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $datos) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['requiredCurriculaIndicator']);
                $spreadsheet->getActiveSheet()->SetCellValue('C' . $aux, $datos['variantConstraintIndicator']);
                $spreadsheet->getActiveSheet()->SetCellValue('D' . $aux, $datos['fundingProgramCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('E' . $aux, $datos['guaranteeTypeCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('F' . $aux, $datos['requiredFinancialGuarantee_Amount']);
                $spreadsheet->getActiveSheet()->SetCellValue('G' . $aux, $datos['language']);
                $spreadsheet->getActiveSheet()->SetCellValue('H' . $aux, $datos['allowedSubcontractTerms']);
                $spreadsheet->getActiveSheet()->SetCellValue('I' . $aux, $datos['description']);
                $spreadsheet->getActiveSheet()->SetCellValue('J' . $aux, $datos['personalSituation']);
                $spreadsheet->getActiveSheet()->SetCellValue('K' . $aux, $datos['procurementLegislationDocumentReference']);
                $aux++;
            }
        }

        return $spreadsheet;
    }

    private function datosCriterioAdjudicacion($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(7);
        $spreadsheet->getActiveSheet()->setTitle("Criterio Adjudicación");

        /*$datos = $this->Xlsexport_model->getDatosRelacionadasTablaWithoutLicitacion("maestro_tendering_terms_awarding_terms", "maestro_tendering_terms", "id_ajena_tt");
        if ($datos['num_rows'] > 0) {
        $aux = 2;

        foreach ($datos['datos'] as $datos) {
        $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_tt']);
        $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['evaluationCriteriaTypeCode']);
        $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['description']);
        $aux++;
        }
        }*/

        return $spreadsheet;
    }

    private function datosCriterioEvaluacionFinanciera($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(8);
        $spreadsheet->getActiveSheet()->setTitle("CriteriosEvaluacionFinanciera");

        $datos = $this->Xlsexport_model->getTenderingTermsCriteriosFinanciacion();
        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $datos) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['evaluationCriteriaTypeCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('C' . $aux, $datos['description']);
                $aux++;
            }
        }
        return $spreadsheet;
    }

    private function datosCriterioEvaluacionTecnica($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(9);
        $spreadsheet->getActiveSheet()->setTitle("Criterios Evaluación Técnica");

        $datos = $this->Xlsexport_model->getTenderingTermsCriteriosTecnicos();
        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $datos) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['evaluationCriteriaTypeCode']);
                $spreadsheet->getActiveSheet()->SetCellValue('C' . $aux, $datos['description']);
                $aux++;
            }
        }

        return $spreadsheet;
    }

    private function datosRequisitosParticipacion($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(10);
        $spreadsheet->getActiveSheet()->setTitle("Requisitos Participación");

        $datos = $this->Xlsexport_model->getTenderingTermsRequisitos();
        if ($datos['num_rows'] > 0) {
            $aux = 2;
            foreach ($datos['datos'] as $datos) {
                $spreadsheet->getActiveSheet()->SetCellValue('A' . $aux, $datos['id_ajena_licitacion']);
                $spreadsheet->getActiveSheet()->SetCellValue('B' . $aux, $datos['evaluationCriteriaTypeCode']);
                $aux++;
            }

        }
        return $spreadsheet;
    }

    private function datosCompletosDocumentosGenerales($spreadsheet, $datosLicitacion)
    {

        $spreadsheet->setActiveSheetIndex(11);
        $spreadsheet->getActiveSheet()->setTitle("Documentos Generales");
        foreach ($datosLicitacion['generalDocs'] as $doc) {
            $spreadsheet->getActiveSheet()->SetCellValue('A' . $this->filaDocumentoGeneral, $doc['id_ajena_licitacion']);
            $spreadsheet->getActiveSheet()->SetCellValue('B' . $this->filaDocumentoGeneral, $doc['attachment']);
            $spreadsheet->getActiveSheet()->SetCellValue('C' . $this->filaDocumentoGeneral, $doc['fileName']);
            $spreadsheet->getActiveSheet()->SetCellValue('D' . $this->filaDocumentoGeneral, $doc['idDoc']);

            $this->filaDocumentoGeneral++;
        }

        return $spreadsheet;
    }

    private function datosCompletosDocumentosAdicionales($spreadsheet, $datosLicitacion)
    {
        $spreadsheet->setActiveSheetIndex(12);
        $spreadsheet->getActiveSheet()->setTitle("Documentos Adicionales");
        foreach ($datosLicitacion['additDocs'] as $doc) {
            $spreadsheet->getActiveSheet()->SetCellValue('A' . $this->filaDocumentoAdd, $doc['id_ajena_licitacion']);
            $spreadsheet->getActiveSheet()->SetCellValue('B' . $this->filaDocumentoAdd, $doc['attachment']);
            $spreadsheet->getActiveSheet()->SetCellValue('C' . $this->filaDocumentoAdd, $doc['idDoc']);
            $spreadsheet->getActiveSheet()->SetCellValue('D' . $this->filaDocumentoAdd, $doc['documentHash']);

            $this->filaDocumentoAdd++;
        }
        return $spreadsheet;
    }

    private function datosCompletosDocumentosTecnicos($spreadsheet, $datosLicitacion)
    {
        $spreadsheet->setActiveSheetIndex(13);
        $spreadsheet->getActiveSheet()->setTitle("Documentos Técnicos");
        foreach ($datosLicitacion['techDocs'] as $doc) {
            $spreadsheet->getActiveSheet()->SetCellValue('A' . $this->filaDocumentoTech, $doc['id_ajena_licitacion']);
            $spreadsheet->getActiveSheet()->SetCellValue('B' . $this->filaDocumentoTech, $doc['attachment']);
            $spreadsheet->getActiveSheet()->SetCellValue('C' . $this->filaDocumentoTech, $doc['idDoc']);
            $spreadsheet->getActiveSheet()->SetCellValue('D' . $this->filaDocumentoTech, $doc['documentHash']);

            $this->filaDocumentoTech++;
        }
        return $spreadsheet;
    }

    private function datosCompletosDocumentosLegales($spreadsheet, $datosLicitacion)
    {
        $spreadsheet->setActiveSheetIndex(14);
        $spreadsheet->getActiveSheet()->setTitle("Documentos Legales");
        foreach ($datosLicitacion['legalDocs'] as $doc) {
            $spreadsheet->getActiveSheet()->SetCellValue('A' . $this->filaDocumentoLegal, $doc['id_ajena_licitacion']);
            $spreadsheet->getActiveSheet()->SetCellValue('B' . $this->filaDocumentoLegal, $doc['attachment']);
            $spreadsheet->getActiveSheet()->SetCellValue('C' . $this->filaDocumentoLegal, $doc['idDoc']);
            $spreadsheet->getActiveSheet()->SetCellValue('D' . $this->filaDocumentoLegal, $doc['documentHash']);

            $this->filaDocumentoLegal++;
        }
        return $spreadsheet;
    }

    private function cabecerasOpenPlacspFirstSheet($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(0);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', "Identificador");
        $spreadsheet->getActiveSheet()->SetCellValue('B1', "Link licitación");
        $spreadsheet->getActiveSheet()->SetCellValue('C1', "Fecha actualización");
        $spreadsheet->getActiveSheet()->SetCellValue('D1', "Vigente/Anulada/Archivada");
        $spreadsheet->getActiveSheet()->SetCellValue('E1', "Primera publicación");
        $spreadsheet->getActiveSheet()->SetCellValue('F1', "Estado");
        $spreadsheet->getActiveSheet()->SetCellValue('G1', "Número de expediente");
        $spreadsheet->getActiveSheet()->SetCellValue('H1', "Objeto del Contrato");
        $spreadsheet->getActiveSheet()->SetCellValue('I1', "Valor estimado del contrato");
        $spreadsheet->getActiveSheet()->SetCellValue('J1', "Presupuesto base sin impuestos");
        $spreadsheet->getActiveSheet()->SetCellValue('K1', "Presupuesto base con impuestos");
        $spreadsheet->getActiveSheet()->SetCellValue('L1', "CPV");
        $spreadsheet->getActiveSheet()->SetCellValue('M1', "Tipo de contrato");
        $spreadsheet->getActiveSheet()->SetCellValue('N1', "Lugar de ejecución");
        $spreadsheet->getActiveSheet()->SetCellValue('O1', "Órgano de Contratación");
        $spreadsheet->getActiveSheet()->SetCellValue('P1', "ID OC en PLACSP");
        $spreadsheet->getActiveSheet()->SetCellValue('Q1', "NIF OC");
        $spreadsheet->getActiveSheet()->SetCellValue('R1', "DIR3");
        $spreadsheet->getActiveSheet()->SetCellValue('S1', "Enlace al Perfil de Contratante del OC");
        $spreadsheet->getActiveSheet()->SetCellValue('T1', "Tipo de Administración");
        $spreadsheet->getActiveSheet()->SetCellValue('U1', "Código Postal");
        $spreadsheet->getActiveSheet()->SetCellValue('V1', "Tipo de procedimiento");
        $spreadsheet->getActiveSheet()->SetCellValue('W1', "Sistema de contratación");
        $spreadsheet->getActiveSheet()->SetCellValue('X1', "Tramitación");
        $spreadsheet->getActiveSheet()->SetCellValue('Y1', "Forma de presentación de la oferta");
        $spreadsheet->getActiveSheet()->SetCellValue('Z1', "Directiva de aplicación");
        $spreadsheet->getActiveSheet()->SetCellValue('AA1', "Subcontratación permitida");
        $spreadsheet->getActiveSheet()->SetCellValue('AB1', "Duración Contrato");
        $spreadsheet->getActiveSheet()->SetCellValue('AC1', "Tipo de duración");
        $spreadsheet->getActiveSheet()->SetCellValue('AD1', "Inicio contrato");
        $spreadsheet->getActiveSheet()->SetCellValue('AE1', "Fin contrato");
        $spreadsheet->getActiveSheet()->SetCellValue('AF1', "Extension Contrato");
        $spreadsheet->getActiveSheet()->SetCellValue('AG1', "URL Organo Contratación");
        $spreadsheet->getActiveSheet()->SetCellValue('AH1', "Ciudad Organo Contratación");
        $spreadsheet->getActiveSheet()->SetCellValue('AI1', "Dirección Organo Contratación");
        $spreadsheet->getActiveSheet()->SetCellValue('AJ1', "Nombre Contacto Organo Contratación");
        $spreadsheet->getActiveSheet()->SetCellValue('AK1', "Email contacto Organo Contratación");
        return $spreadsheet;
    }

    //Cabeceras
    private function cabecerasOpenPlacspDocumentos($spreadsheet, $hojaActiva)
    {
        $spreadsheet->setActiveSheetIndex($hojaActiva);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', "Identificador");
        $spreadsheet->getActiveSheet()->SetCellValue('B1', "Link Documento");
        $spreadsheet->getActiveSheet()->SetCellValue('C1', "Nombre Documento");
        $spreadsheet->getActiveSheet()->SetCellValue('D1', "Hash Documento");

        return $spreadsheet;
    }

    private function cabecerasOpenPlacsBitacora($spreadsheet, $hojaActiva)
    {
        $spreadsheet->setActiveSheetIndex($hojaActiva);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', "Identificador");
        $spreadsheet->getActiveSheet()->SetCellValue('B1', "Objeto del lote");
        $spreadsheet->getActiveSheet()->SetCellValue('C1', "Número de lote");
        $spreadsheet->getActiveSheet()->SetCellValue('D1', "Importe sin Impuestos");
        $spreadsheet->getActiveSheet()->SetCellValue('E1', "Importe con Impuestos");
        $spreadsheet->getActiveSheet()->SetCellValue('F1', "Lugar de ejecución del lote");
        $spreadsheet->getActiveSheet()->SetCellValue('G1', "Codigo de ejecución del lote");
        $spreadsheet->getActiveSheet()->SetCellValue('H1', "Ciudad de ejecución del lote");
        $spreadsheet->getActiveSheet()->SetCellValue('I1', "CPV Project Lot");

        return $spreadsheet;
    }

    private function cabeceraMediosComunicacion($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(2);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Tipo de anuncio');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Medio de publicación');

        return $spreadsheet;
    }

    private function cabeceraMediosComunicacionDocumentos($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(3);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Documento');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Nombre Documento');

        return $spreadsheet;
    }

    private function cabeceraTenderResult($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(4);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Tipo de resultado');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Motivación adjudicación');
        $spreadsheet->getActiveSheet()->SetCellValue('D1', 'Fecha del acuerdo');
        $spreadsheet->getActiveSheet()->SetCellValue('E1', 'Número de licitadores participadores');
        $spreadsheet->getActiveSheet()->SetCellValue('F1', 'Importe Oferta mas baja');
        $spreadsheet->getActiveSheet()->SetCellValue('G1', 'Importe Oferta mas alta');
        $spreadsheet->getActiveSheet()->SetCellValue('H1', 'Fecha de entrada en vigor');
        $spreadsheet->getActiveSheet()->SetCellValue('I1', 'Identifica si es una PYME');
        $spreadsheet->getActiveSheet()->SetCellValue('J1', 'Identificador del contrato');
        $spreadsheet->getActiveSheet()->SetCellValue('K1', 'Fecha de formalización');
        $spreadsheet->getActiveSheet()->SetCellValue('L1', 'Adjudicatario CIF');
        $spreadsheet->getActiveSheet()->SetCellValue('M1', 'Nombre Adjudicatario');
        $spreadsheet->getActiveSheet()->SetCellValue('N1', 'Importe de adjudicación sin impuestos');
        $spreadsheet->getActiveSheet()->SetCellValue('O1', 'Importe de adjudicación con impuestos');

        return $spreadsheet;
    }

    private function cabeceraTipoProcedimiento($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(5);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Tipo de Procedimiento');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Tipo de Tramitación');
        $spreadsheet->getActiveSheet()->SetCellValue('D1', 'Sistema de Contratación');
        $spreadsheet->getActiveSheet()->SetCellValue('E1', 'Número de lotes a los que se debe ofertar');
        $spreadsheet->getActiveSheet()->SetCellValue('F1', 'Presentación de la oferta');
        $spreadsheet->getActiveSheet()->SetCellValue('G1', 'Número de lotes a los que se puede ofertar');
        $spreadsheet->getActiveSheet()->SetCellValue('H1', 'Número máximo de lotes que se puede adjudicar un licitador');
        $spreadsheet->getActiveSheet()->SetCellValue('I1', 'El poder adjudicador se reserva el derecho de adjudicar contratos que combinen lotes');
        $spreadsheet->getActiveSheet()->SetCellValue('J1', 'Fecha limite para la presentación de ofertas');
        $spreadsheet->getActiveSheet()->SetCellValue('K1', 'Tiempo limite para la presentación de ofertas');
        $spreadsheet->getActiveSheet()->SetCellValue('L1', 'Texto descriptivo de fecha limite de presentación de ofertas');
        $spreadsheet->getActiveSheet()->SetCellValue('M1', 'Usa subasta electronica');
        $spreadsheet->getActiveSheet()->SetCellValue('N1', 'Fecha límite para obtener los pliegos');
        $spreadsheet->getActiveSheet()->SetCellValue('O1', 'Hora límite para obtener los pliegos');

        return $spreadsheet;
    }

    private function cabeceraTenderingTerms($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(6);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Se requiere la presentación de Curriculum Vitae de las personas que realizarán el proyecto');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Indica que se pueden ofertar variantes');
        $spreadsheet->getActiveSheet()->SetCellValue('D1', 'Código descriptivo del tipo de programas que financian este contrato');
        $spreadsheet->getActiveSheet()->SetCellValue('E1', 'Tipo de garantia');
        $spreadsheet->getActiveSheet()->SetCellValue('F1', 'Porcentaje de la garantíaa');
        $spreadsheet->getActiveSheet()->SetCellValue('G1', 'Idioma');
        $spreadsheet->getActiveSheet()->SetCellValue('H1', 'Porcentaje de subcontratación máximo especificado para este contrato.');
        $spreadsheet->getActiveSheet()->SetCellValue('I1', 'Descripción del objeto de la subcontratación');
        $spreadsheet->getActiveSheet()->SetCellValue('J1', 'Descripción textual de los requisitos específicos del operador económico para poder participar en la licitación');
        $spreadsheet->getActiveSheet()->SetCellValue('K1', 'Contrato sujeto a regulación armonizadaF');

        return $spreadsheet;
    }

    private function cabeceraCriterioADjudicacion($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(7);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Tipo criterio de adjudicación');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Descripción textual del criterio de adjudicación');

        return $spreadsheet;
    }

    private function cabeceraCriteriosFinancieros($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(8);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Tipo criterio de evaluación financiera');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Descripción textual del criterio de evaluación financiera');

        return $spreadsheet;
    }

    private function cabeceraCriteriosTecnicos($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(9);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Tipo criterio de evaluación técnica');
        $spreadsheet->getActiveSheet()->SetCellValue('C1', 'Descripción textual del criterio de evaluación técnica');

        return $spreadsheet;
    }

    private function cabeceraRequisitosParticipacion($spreadsheet)
    {
        $spreadsheet->setActiveSheetIndex(10);
        $spreadsheet->getActiveSheet()->SetCellValue('A1', 'Identificador');
        $spreadsheet->getActiveSheet()->SetCellValue('B1', 'Tipo Requisitos Participacion');

        return $spreadsheet;
    }

}

/* End of file ExportXls.php */
/* Location: ./application/controllers/ExportXls.php */
